#ifndef H_myDynamicArray
#define H_myDynamicArray
// Preprocessor directive used to avoid   problems  resulting from multiple include.
// See [Malik, pages 637-638].


#include <iostream>
using namespace std;
#include <cmath>
////////////////////////////////////////////////////////////////////////////////////////////////////

template<class Type>
class myDynamicArray
{

protected:
	Type * A;
	int size;
public:
	myDynamicArray(int sizeValue);
	myDynamicArray();
	myDynamicArray(const myDynamicArray<Type> & other);
    ~myDynamicArray();
	const myDynamicArray<Type>&  operator=(const myDynamicArray<Type> & other);
	void copy(const myDynamicArray<Type> & copied);
	
    void set(int i, Type x);
	Type get(int i) const;
	int getSize() const;

	void print() const;
	
	int search(Type query) const;
	bool isSorted() const;
	void insertionSort();


    void concatinate(myDynamicArray & B);

};
////////////////////////////////////////////////////////////////////////////////////////////////////

template<class Type>
myDynamicArray<Type>::myDynamicArray()
{
	A= new Type[999];
	size=999;
	for(int i=0;i<size;i++)
		A[i]=0;
}


template<class Type>
myDynamicArray<Type>::myDynamicArray(int sizeValue)
{
	size=sizeValue;
	A=new Type[size];
	for(int i=0;i<size;i++)
		A[i]=0;
}



template<class Type>
myDynamicArray<Type>::~myDynamicArray()
{
	delete [] A;
	size = 0;
}



template<class Type>
myDynamicArray<Type>::myDynamicArray(const myDynamicArray<Type> & other)
{
    copy(other);
}


template<class Type>
const myDynamicArray<Type>&  myDynamicArray<Type>::operator=(const myDynamicArray<Type> & other)
{
	if(this != & other) 
		   copy(other);
	return *this;        
}


template<class Type>
void myDynamicArray<Type>::set(int i, Type x)
{
	A[i] = x;
}
	


template<class Type>
Type myDynamicArray<Type>::get(int i) const
{
	return A[i];
   
}


template<class Type>
int myDynamicArray<Type>::getSize() const
{
	return size;
   
}



template<class Type>
int myDynamicArray<Type>::search(Type query) const
{
	for(int i=0; i<size; i++)
	if(A[i]==query) return i;
	return -1;
}

template<class Type>
void myDynamicArray<Type>::print() const
{
	for(int i=0;i<size;i++)
		cout<<A[i]<<" ";
	cout<<endl;
}


template<class Type>
bool myDynamicArray<Type>::isSorted() const
{
	bool sorted=true;
	for(int i=1;i<size;i++)
		if(A[i-1]>A[i]) sorted=false;
	return sorted;
}


template<class Type>
void myDynamicArray<Type>::insertionSort()
{
	Type temp;
	for(int j=1;j<size;j++) {
		temp=A[j];
		for(int i=j-1; (A[i]>temp) && (i>-1);i--)
			A[i+1]=A[i];
			A[i+1]=temp;
	}
}


template<class Type>
void myDynamicArray<Type>::copy(const myDynamicArray & copied)
{
	delete [] A;
	A = new  Type[copied.size];
	size=copied.size;
	for(int i=0; i<size; i++)
		 A[i]=copied.A[i];
}

template<class Type>
void myDynamicArray<Type>::concatinate(myDynamicArray & B)
{
	Type * final;
	final = new Type[size+B.size];
	for(int i=0;i<size;i++)
		final[i]=A[i];
	for(i=size; i<(size+B.size); i++)
		final[i]=B.A[i-size];
	delete [] A;
	A = final;
	size=size + B.size;
}

/////////////////////////////////////////////////////////////////////////////////////////////////////


#endif

